=== debian/changelog ===
openmm (7.7.0+dfsg-9) unstable; urgency=medium

  * Adjust cmake build directory in debian/rules to build on i686 and some
    other architectures.

 -- Andrius Merkys <merkys@debian.org>  Sat, 01 Oct 2022 06:52:44 -0400

openmm (7.7.0+dfsg-8) unstable; urgency=medium

  * Fix OpenCL plugin build.
  * Turn off OpenCL tests as they cannot be run on buildds.

 -- Andrius Merkys <merkys@debian.org>  Wed, 28 Sep 2022 09:52:38 -0400

openmm (7.7.0+dfsg-7) unstable; urgency=medium

  * Fix default plugin location. Earlier hard-coded location did not follow the
    real install path for shared libraries, thus only the reference platform
    for OpenMM was found.

 -- Andrius Merkys <merkys@debian.org>  Thu, 23 Jun 2022 06:32:27 -0400

openmm (7.7.0+dfsg-6) unstable; urgency=medium

  * Backport upstream patch for GCC-12 FTBFS (Closes: #1013010).

 -- Andrius Merkys <merkys@debian.org>  Mon, 20 Jun 2022 03:18:38 -0400

openmm (7.7.0+dfsg-5) unstable; urgency=medium

  * Fix reproducibility issue by un-embedding build paths.
  * Set OPENMM_CUDA_COMPILER in debian/rules for downstream builds with
    nvidia-cuda-toolkit.
  * Add Provides and X-Python3-Version to Python package.
  * Update debian/todo.

 -- Andrius Merkys <merkys@debian.org>  Tue, 05 Apr 2022 11:20:27 -0400

openmm (7.7.0+dfsg-4) unstable; urgency=medium

  * Add missing dependencies for python3-simtk.
  * Add autopkgtest.
  * Set RPATH for Python to find libraries in OpenMM private location
    (Closes: #1004750).
  * Add ${shlibs:Depends} to libopenmm-dev.
  * Correct capitalization for Python programming language name.
  * Bump copyright year.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Tue, 22 Mar 2022 11:22:16 -0400

openmm (7.7.0+dfsg-3) unstable; urgency=medium

  * Reverting cleaning up debian/rules as removed variables were needed
    by the build system.

 -- Andrius Merkys <merkys@debian.org>  Mon, 24 Jan 2022 03:34:02 -0500

openmm (7.7.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * Setting CMAKE_BUILD_RPATH_USE_ORIGIN=ON to fix reproducible build
    (Closes: #1004005).
  * Cleaning up debian/rules.
  * Moving libOpenMMAmoeba.so, libOpenMMDrude.so and libOpenMMRPMD.so to
    libdevel package.
  * Updating debian/todo.

 -- Andrius Merkys <merkys@debian.org>  Mon, 24 Jan 2022 01:45:05 -0500

openmm (7.7.0+dfsg-1) experimental; urgency=medium

  * New upstream version 7.7.0+dfsg
  * Accommodating SONAME bump.
  * Refreshing skip-tests.patch, skipping two more tests.
  * Building python3-simtk package.
  * Including libOpenMMAmoeba.so, libOpenMMDrude.so and libOpenMMRPMD.so in
    libs package (Closes: #992931).

 -- Andrius Merkys <merkys@debian.org>  Thu, 23 Dec 2021 08:34:13 -0500

openmm (7.6.0+dfsg-1) unstable; urgency=medium

  * New upstream version 7.6.0+dfsg

 -- Andrius Merkys <merkys@debian.org>  Sat, 28 Aug 2021 02:31:22 -0400

openmm (7.5.1+dfsg-2) unstable; urgency=medium

  * No-changes source-only upload to unstable.

 -- Andrius Merkys <merkys@debian.org>  Sun, 15 Aug 2021 01:37:12 -0400

openmm (7.5.1+dfsg-1) experimental; urgency=medium

  [ Steffen Möller ]
  * Update metadata - added refs to bio.tools, conda, SciCrunch

  [ Andrius Merkys ]
  * New upstream version 7.5.1+dfsg
  * Skipping yet another test due to unsupported platform.
  * Adding a binary package for plugins.
  * Updating copyright years.

 -- Andrius Merkys <merkys@debian.org>  Fri, 02 Jul 2021 03:16:58 -0400
