=== debian/tests/control ===
Test-Command: cd wrappers/python/tests && pytest-3
Depends:
 python3-pytest,
 python3-simtk,
Restrictions:
 rw-build-tree,
